#--------------------------------------------------------------------------
#  InsertDate Service Example
#  Copyright (c) 1998, AAA+ Software (info@aaa-plus.com)
#  All rights reserved.
#  Author: W. Pitzeier
#
#  You may freely copy, distribute and reuse the code in this example.
#  AAA+ disclaims any warranty of any kind, expressed or implied,
#  as to its fitness for any particular use.
#--------------------------------------------------------------------------

objc:teach $NSApp {

    # gets called when the user clicks "Insert" or "Cancel"
    - void closeModalPanel: sender {
         $self stopModalWithCode: [$sender tag]
    }

    # updates the date string according to the format string
    - void setDate: sender {
        global dateResult dateFormat
        $dateResult setStringValue: [@ [clock format [clock seconds] -format [* [$dateFormat stringValue]]]]
    }

    # service method implementation
    - void date: pboard userData: data error: {{id *} error} {
        global datePanel dateResult
        $self setDate: $self
        $self activateIgnoringOtherApps: [YES]
        set tag [$self runModalForWindow: $datePanel]
        $datePanel close
        if {$tag} {
            $pboard declareTypes: [NSArray arrayWithObject: [NSStringPboardType]] owner: nil
            $pboard setString: [$dateResult stringValue] forType: [NSStringPboardType]
        }
    }
}


# We don't need ProjectBuilder and compileHelp for context help
objc:teach NSHelpManager {
    # handy resusable method
    - void setContextHelpFromRTFResource: resource forObject: object {
	    # ugly hard-coded path
        set bundle [NSBundle bundleWithPath: [@ /LocalLibrary/Services/InsertDate.service]]
        set data [NSData dataWithContentsOfFile: [$bundle pathForResource: $resource ofType: [@ rtf]]]
        $self setContextHelp: [[NSAttributedString alloc] initWithRTF: $data documentAttributes: nil] forObject: $object
    }
}

# first time service startup
$datePanel center
[NSHelpManager sharedHelpManager] setContextHelpFromRTFResource: [@ DateFormats] forObject: $dateFormat

# update the date string every second
# good if you use %S or if you work around midnight :-)
$self eval: "$NSApp setDate: $self" every: 1.0 modes: [NSArray arrayWithObject: [NSModalPanelRunLoopMode]]
